// ============================================================================
// ==                                                                        ==
// == Amdis - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ==  http://www.amdis-fem.org                                              ==
// ==                                                                        ==
// ============================================================================
//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.



/** \file ArhReader.h */

#ifndef AMDIS_ARH_READER_H
#define AMDIS_ARH_READER_H

#include "AMDiS_fwd.h"

namespace AMDiS {

  using namespace std;

  class ArhReader
  {
  public:
    static void read(string filename, Mesh *mesh,
		     DOFVector<double>* vec0 = NULL, 
		     DOFVector<double>* vec1 = NULL,
		     DOFVector<double>* vec2 = NULL,		     
		     bool writeParallel = true,
		     int nProcs = -1);

    static void read(string filename, Mesh *mesh, 
		     vector<DOFVector<double>*> vecs,
		     bool writeParallel = true,
		     int nProcs = -1);

  private:

    static void readFile(string filename, 
			 Mesh *mesh,
			 vector<DOFVector<double>*> vecs);

    static void setDofValues(int macroElIndex, Mesh *mesh, 
			     vector<double>& values, DOFVector<double>* vec);
  };
}

#endif
