// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ==  http://www.amdis-fem.org                                              ==
// ==                                                                        ==
// ============================================================================
//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.



/** \file Mtl4Solver.h */

#ifndef AMDIS_MTL4_SOLVER_H
#define AMDIS_MTL4_SOLVER_H

#include "ParallelProblemStatBase.h"

namespace AMDiS {

  namespace Parallel {
    class Mtl4Solver : public ParallelProblemStatBase
    {
      void addPMTLSolvers();
      //void addPMTLPrecons();
    public:
      Mtl4Solver(std::string nameStr,
             ProblemIterationInterface *problemIteration = NULL)
        : ParallelProblemStatBase(nameStr, problemIteration)
      {
	addPMTLSolvers();
	//addPMTLPrecons();
      }

    
      ~Mtl4Solver()
      {}


      void solve(AdaptInfo *adaptInfo, bool createMatrixData = true,
	       bool storeMatrixData = false );
      void createPrecon();
      void createSolver();
    };
  }

  typedef Parallel::Mtl4Solver ParallelProblemStat;
  typedef ParallelProblemStat  ProblemStat;
}

#endif
